#include "ApproximateMatcher.h"

ApproximateMatcher::ApproximateMatcher(bool countOnly) {
	this->countOnly = countOnly;
	numberOfMatchings = 0;
}

ull ApproximateMatcher::getNumberOfMatchings() {
	return numberOfMatchings;
}

void ApproximateMatcher::registerAMatching(char* chunk, int matchingPos, size_t m, int error) {
	++numberOfMatchings;

	if(!countOnly) {
		int ini = matchingPos - m + 1;
		for(int i = 0; i < 10 && ini > 0 && chunk[ini-1] != '\n'; ++i, --ini);

		char tmp = chunk[matchingPos+1];
		chunk[matchingPos+1] = 0;
		printf("%s\n", chunk + ini);
		chunk[matchingPos+1] = tmp;
	}
}