#include "AhoList.h"

AhoList::AhoList() : first(NULL), last(NULL), size(0) {
}

void AhoList::add(const char* pat, int patSize){
	AhoNode* toAdd = new AhoNode(pat, patSize);
	if(!first) first = last = toAdd;
	else {
		last -> next = toAdd;
		last = toAdd;
	}

	++size;
}

void AhoList::concatenate(AhoList* other){
	if(size == 0) { //Empty + Anything
		first = other->first;
		last = other->last;
	} else if(other->first) { //NonEmpty + NonEmpty
		last -> next = other->first;
		last = other->last;
	}
	size += other -> size;
}
