#ifndef BRUTE_FORCE
#define BRUTE_FORCE

#include "ExactMatcher.h"

/*
 * Algoritmo de força bruta para padrões unitários.
 */
class BruteForce : public ExactMatcher {
public:
	BruteForce(bool countOnly, const char* pattern, size_t m);

	//Ver Matcher::update
	int update(char* buf, size_t bufSize);
	
	const char* getAlgoName(){
		return "BruteForce";
	}

	void resetForNewFile(){
		n = 0;
		numberOfMatchings = 0;
	}
	
private:
	char pattern; //O padrão: cadeia de tamanho = 1
	size_t n; //O tamanho do texto recebido até agora
};

#endif
