#include "ExactMatcher.h"

ExactMatcher::ExactMatcher(bool countOnly) {
	numberOfMatchings = 0;
	this->countOnly = countOnly;
}

ull ExactMatcher::getNumberOfMatchings(){
	return numberOfMatchings;
}

void ExactMatcher::registerAMatching(char* chunk, int matchingPos, size_t m) {
	++numberOfMatchings;

	if(!countOnly) {
		int initialPos = matchingPos - m + 1, endingPos = matchingPos;
		for(int i = 0; i < 10 && initialPos > 0 && chunk[initialPos-1] != '\n'; ++i, --initialPos);
		for(int i = 0; i < 10 && chunk[endingPos+1] != 0 && chunk[endingPos+1] != '\n'; ++i, ++endingPos);

		//Imprime os caracteres antes da ocorrência
		if(initialPos <= matchingPos - m) {
			char tmp = chunk[matchingPos-m+1];
			chunk[matchingPos-m+1] = 0;
			printf("%s", chunk + initialPos);
			chunk[matchingPos-m+1] = tmp;
		}

		//Imprime a ocorrência
		if(COLORED_PRINTING_IS_ENABLED) printf("%s", RED_COLOR);
		char tmp = chunk[matchingPos+1];
		chunk[matchingPos+1] = 0;
		printf("%s", chunk + matchingPos-m+1);
		chunk[matchingPos+1] = tmp;
		if(COLORED_PRINTING_IS_ENABLED) printf("%s", RESET_COLOR);

		//Imprime os caracters depois da ocorrência
		if(endingPos > matchingPos) {
			char tmp = chunk[endingPos+1];
			chunk[endingPos+1] = 0;
			printf("%s", chunk + matchingPos + 1);
			chunk[endingPos+1] = tmp;
		}

		//Imprime uma quebra de linha
		puts("");
	}
}