#ifndef SHIFT_OR
#define SHIFT_OR

#include "ExactMatcher.h"
#include "MyBinaryInteger.h"

class ShiftOr : public ExactMatcher {
public:
	ShiftOr(bool countOnly, const char* pattern, size_t m);

	//Ver Matcher::update
	int update(char* chunk, size_t chunkSize);

	const char* getAlgoName(){
		return "ShiftOr";
	}

	void resetForNewFile() {
		n = 0;
		S.setup(m);
		numberOfMatchings = 0;
	}

private:
	//As máscaras relativas a cada letra do alfabeto e suas ocorrências no padrão
	MyBinaryInteger* C;

	//A máscara do casamento atual
	MyBinaryInteger S;

	const char* pattern;
	size_t m; //O tamanho do padrão

	size_t n; //O tamanho do texto recebido até agora	

	void buildCharMasks();
};

#endif