#ifndef APPROXIMATE_MATCHER
#define APPROXIMATE_MATCHER

#include "Global.h"
#include "Matcher.h"

class ApproximateMatcher : public Matcher {
public:
	ApproximateMatcher(bool countOnly);

	virtual int update(char* chunk, size_t chunkSize) = 0;

	virtual ull getNumberOfMatchings();

protected:
	void registerAMatching(char* chunk, int matchingPos, size_t m, int error);
	ull numberOfMatchings;

private:
	bool countOnly;
};

#endif