#ifndef AHO_LIST
#define AHO_LIST
#include "Global.h"

struct AhoNode {
	const char* pattern;
	int size;
	AhoNode* next;

	AhoNode(const char* pat, int size) : pattern(pat), size(size), next(NULL) {}
};

class AhoList {
public:
	AhoNode* first, *last;
	int size;

	AhoList();
	void add(const char* pat, int patSize);
	void concatenate(AhoList* other);
};
#endif